
import 'package:cs_resources/generated/assets.dart';
import 'package:cs_resources/generated/l10n.dart';
import 'package:flutter/cupertino.dart';
import 'package:plugin_platform/engine/toast/toast_engine.dart';
import 'package:riverpod_annotation/riverpod_annotation.dart';
import 'package:shared/utils/log_utils.dart';

import './rewards_history_earned/rewards_history_earned_page.dart';
import './rewards_history_spent/rewards_history_spent_page.dart';

part 'rewards_history_vm.g.dart';


class RewardsHistoryVmState {
  List<Map<String, dynamic>>? topSectionsData;
  int? curIdx;

  RewardsHistoryVmState({
    List<Map<String, dynamic>>? topSectionsData,
    this.curIdx = 0,
  }) : topSectionsData = topSectionsData?? [
    {
      "title": S.current.earned_points,
      "icon": Assets.propertyIoan,
      "pageStartInstanceFn": RewardsHistoryEarnedPage.startInstance,
      "page": const RewardsHistoryEarnedPage(),
    },
    {
      "title": S.current.spent_points,
      "icon": Assets.propertyNews,
      "pageStartInstanceFn": RewardsHistorySpentPage.startInstance,
      "page": const RewardsHistorySpentPage(),
    },
  ];

  RewardsHistoryVmState copyWith({
    List<Map<String, dynamic>>? topSectionsData,
    int? curIdx = 0,
  }) {
    return RewardsHistoryVmState(
      topSectionsData: topSectionsData ?? this.topSectionsData,
      curIdx: curIdx ?? 0,
    );
  }
}

@riverpod
class RewardsHistoryVm extends _$RewardsHistoryVm {
  get topSectionsData => state.topSectionsData;

  RewardsHistoryVmState initState() {
    return RewardsHistoryVmState();
  }

  @override
  RewardsHistoryVmState build(){
    final state = initState();
    Log.d("--------------------------build---------------------");

    // 初始时导航到子路由
    WidgetsBinding.instance.addPostFrameCallback((_) {
    });

    return state;
  }

  // 页面切换
  switchPage(int index,BuildContext? context, [bool? isFirstInitSwitch] ){
    if(state.curIdx != index){
      state = state.copyWith(curIdx: index);
      final List<Map<String, dynamic>>? topSectionsData = state.topSectionsData;
      // Log.d("当前页面${topSectionsData?[index]['pageStartInstanceFn']}");
      final pageStartInstanceFn = topSectionsData?[index]['pageStartInstanceFn'] as Function({BuildContext? context});
      pageStartInstanceFn(context:context);
    }else {
      if(isFirstInitSwitch??false){
        final List<Map<String, dynamic>>? topSectionsData = state.topSectionsData;
        // Log.d("当前页面${topSectionsData?[index]['pageStartInstanceFn']}");
        final pageStartInstanceFn = topSectionsData?[index]['pageStartInstanceFn'] as Function({BuildContext? context});
        pageStartInstanceFn(context:context);
      }
    }
  }

}

